// MonitorDeSinal.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <string.h>
#include <conio.h>
#include <math.h>
#include "vlibdef.h"

#define DllImport   __declspec(dllimport)

#include "voicerlib.h"

float fNivel,fNivel1,fSinal,fNiveldB = 0;
short nFlagAudio = 0;
short nPorta = 1; 
short nLimiarSilencio=-30;
short nFrequencia = 425;
char szMsg[255];
short cAmostras[400];
int flag=0;
FILE *fp;
int nEstado = 0;
int nTOM,nSilencio = 0;

DWORD TempTickIni   = 0;
DWORD TempTickFim   = 0;
DWORD TempTickDiff  = 0;
DWORD TempTickDiffS = 0;

dg_event_data_structure event_context;

void print_cAmostras(void)
{
	int i=0;

	for (i=0;i<160;i++)
	{
		printf("\ncAmostras[%d] = %d",i,cAmostras);
	}
}

void print_menu(void)
{
	int i;
	printf("\n***********\n");
	printf("* Menu    *\n");
	printf("***********\n");
	printf("<s> Selecionar Porta\n");
	printf("<p> PickUp\n");
	printf("<h> HangUp\n");
	printf("<d> Dial\n");
	printf("<f> Setar frequencia\n");
	printf("<l> Setar limiar de silencio\n");
	printf("<v> Versao do firmware\n");
	printf("<m> Voltar ao menu\n");
	printf("<q> Quit\n"); 
	printf("\n-----------------------------");
	printf("\nNivel do Sinal=%.2f",fNiveldB);
	printf("\n");
	for(i=1; i< (80+(int)fNiveldB)/2;i++)
		printf("|");
	printf("\nFrequencia=%d",nFrequencia);
	printf("\nLimiar de Silencio=%d",nLimiarSilencio);
	printf("\nAudio(tone1)=%d",nFlagAudio);
	printf("\n-----------------------------\n");
	printf("\n*-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
	printf("\n- TOM(ms)=%d",nTOM);
	printf("\n* Silencio(ms)=%d",nSilencio);
	printf("\n-*-*-*-*-*-*-*-*-*-*-*-*-*-*-\n");
}

void print_event(char *szMsg, int port)
{

	struct tm *now;
	time_t curSecs;
	curSecs = time(NULL);
	now = localtime(&curSecs);
	printf("<%02d:%02d:%02d> <%d>: %s\n",now->tm_hour, now->tm_min, now->tm_sec, port,szMsg);
}

void CALLBACK CallSinal(short port, int size, void *Samples)
{
	short i,tempInt=0;	 

	if (port == nPorta)
	{
		if ((size>0) || (size<400))
		{
			memcpy(cAmostras,Samples,(size*2));

			for (i=0;i<size;i++)
			{

				tempInt = cAmostras[i];
				fSinal = tempInt;
				fNivel = ((0.98f * fNivel1) + (0.02f * abs(fSinal/4096.0f)));
				fNivel1 = fNivel;
				fNiveldB = (20.0f * (log10(fNivel)))-10.0f;
				if(flag==1)
				{
					fprintf(fp,"\n%d\t\t%0.2f\t\t%.2f\t\t%02.2f",cAmostras[i],fSinal,fNivel,fNiveldB);
				}
			}
		}
	}
}

void CALLBACK ReceiveEvents(void *context_data)
{
    dg_event_data_structure *EventContext;
    char data[MAX_PATH];
    char szDig[MAX_PATH];
	int ret=0;
	//zera string
    data[0] = 0;


    /* Copy received Data */
    EventContext = ((dg_event_data_structure*)context_data);

		szDig[0] = 0;
 		switch (EventContext->command)
		{
			case EV_AUDIO_SIGNAL:

				switch (EventContext->data)
				{
					case 32://Silencio
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
							TempTickIni = GetTickCount();
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Silencio 0x%x ", EventContext->data);						
						break;

					case 33://Audio
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Audio 0x%x ", EventContext->data);						
						break;

					case 34://Tone 1
						if (nEstado == 0)
						{
							TempTickDiffS = (GetTickCount() - TempTickIni);
							nSilencio = (int)(TempTickDiffS);
							TempTickIni = GetTickCount();
						}
						nEstado = 1;
						nFlagAudio = 1;
						printf(data,"Tone 1 0x%x ", EventContext->data);						
						break;

					case 35://Tone 2
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 2 0x%x ", EventContext->data);						
						break;

					case 36://Tone 3
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 3 0x%x ", EventContext->data);						
						break;

					case 37://Tone 4
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 4 0x%x ", EventContext->data);						
						break;

					case 38://Tone 5
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 5 0x%x ", EventContext->data);						
						break;

					case 39://Tone 6
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 6 0x%x ", EventContext->data);						
						break;

					case 40://Tone 7
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 7 0x%x ", EventContext->data);						
						break;

					case 41://Tone 8
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"Tone 8 0x%x ", EventContext->data);						
						break;

					default:
						if (nEstado == 1)
						{
							TempTickDiff = (GetTickCount() - TempTickIni);
							nTOM = (int)(TempTickDiff);
						}
						nEstado = 0;
						nFlagAudio = 0;
						printf(data,"0x%x ", EventContext->data);
						
				}
		}		
}


int _tmain(int argc, _TCHAR* argv[])
{	
	short ret=0;
	char ch;
	char szTeste[255];
	char szTemp[255];
	int nPortsCount, nCardCount=0;
	short nRet1  = 0; 
	short nForPortas,nForCards = 0;
	int nPointerTemp = 0;

	fNivel			= 0;
	fNivel1			= 0;
	TempTickIni		= 0;
	TempTickFim		= 0;
	TempTickDiff	= 0;
	TempTickDiffS	= 0;

	printf("-------------------------------------------\n");
	printf("-   Monitor de Sinal                      -\n");
	printf("-------------------------------------------\n");

	//passa para a dll o ponteiro da callback que tratara os eventos
	dg_SetEventCallback(ReceiveEvents,&event_context);
	dg_SetAudioInputCallback(&CallSinal); 

	if (argc == 1)
		strcpy(szTeste,"C:\\Arquivos de Programas\\voicerlib4");

	printf("\nFirmware em %s\n\nIniciando VoicerLib - Aguarde...\n", szTeste);

	//inicia voicerlib com o caminho do firmware
	ret = dg_StartVoicerlib(szTeste);

	if (ret!=DG_EXIT_SUCCESS)
	{
		printf("**********************************************************\n");
		printf("* ERRO ERRO ERRO ERRO ERRO ERRO ERRO ERRO ERRO ERRO ERRO *\n");
		printf("* Retorno = %d                                            *\n",ret);
		printf("* O programa sera executado mas nao funcionara           *\n");
		printf("* pois ocorreu algum erro na carga do firmware           *\n");
		printf("**********************************************************\n");
	}
	else
	{
		printf("\nRetorno do StartVoicerLib = r%d\n",ret);
		nPortsCount = dg_GetPortsCount();
		nCardsCount = dg_GetCardsCount(); 

		for (nForPortas = 1; nForPortas <= nPortsCount;nForPortas++) 
		{
			//Seta o limiar de silencio
			nRet1 = dg_SetSilenceThreshold(nForPortas,nLimiarSilencio);
			if (nRet1 != DG_EXIT_SUCCESS) 
				printf("\n(%d)Erro ao setar o limiar de silencio.nRet %d",nForPortas,nRet1);

			//Habilita o input buffer
			nRet1 = dg_EnableInputBuffer(nForPortas,DG_DISABLE_AGC);
			if (nRet1 != DG_EXIT_SUCCESS) 
				printf("\n(%d)Erro ao habilitar InputBuffer.nRet %d",nForPortas,nRet1);

			//Seta formato de gravacao
			nRet1 = dg_SetRecordFormat(nForPortas,ffWavePCM);
			if (nRet1 != DG_EXIT_SUCCESS)
				printf("\n(%d)Erro ao setar o formato de gravacao como PCM.nRet %d",nForPortas, nRet1);

			//Seta o ganho de gravacao
			nRet1 = dg_SetRecordGain(nForPortas,0);
			if (nRet1 != DG_EXIT_SUCCESS) 
				printf("\n(%d)Erro ao setar o ganho de gravacao.nRet %d", nForPortas,nRet1);

			nRet1 = dg_SetDetectionType(nForPortas,DETECT_TONE1,DG_ENABLE);
			if (nRet1 != DG_EXIT_SUCCESS)
				printf("\n(%d)Erro ao setar o tipo de deteccao.nRet %d",nForPortas,nRet1);
		}
	}
	
	while(1)
	{
		Sleep(200);
		//limpa a tela
		system("cls");
		print_menu();

		ch=0;
		if(_kbhit())	
			ch = getch();

		if (ch=='q' || ch=='Q')
		{
				//Finaliza a VoicerLib
				nRet1 = dg_ShutdownVoicerlib();
				if (nRet1 != DG_EXIT_SUCCESS)
					printf("\nErro ao finalizar a Voicerlib.nRet %d",nRet1);
			break;
		}		

		if(ch !=0)

			switch(ch)
			{

				case 's'://Selecionar a porta
				case 'S':
					printf("\nEntre com a porta: ");
					fflush(stdin);
					scanf_s("%s",szTemp,sizeof(szTemp));
					nPorta = atoi(szTemp);
					break;

				case 'p'://PickUp
				case 'P':
					//inicia discagem
					nRet1 = dg_PickUp(nPorta,100);
					if (nRet1 != DG_EXIT_SUCCESS)
						printf("Erro ao atender a porta %d. nRet.: %d\n",nPorta,nRet1);
					else
						printf("Atendeu a porta %d com sucesso\n",nPorta);				
				break;

				case 'h'://HangUp
				case 'H':
					//desliga porta
					nRet1 = dg_HangUp(nPorta);
					if (nRet1 != DG_EXIT_SUCCESS)
						printf("Erro ao desligar a porta %d. nRet.: %d\n",nPorta,nRet1);
					else
						printf("Desligou a porta %d com sucesso\n",nPorta);
					break;

				case 'd'://Dial
				case 'D':					
					printf("\nEntre com o numero: ");
					fflush(stdin);
					scanf_s("%s",szTemp,sizeof(szTemp));

					//inicia discagem
					nRet1 = dg_PickUp(nPorta,0);
					if (nRet1 != DG_EXIT_SUCCESS)
						printf("Erro ao atender a porta %d. nRet.: %d\n",nPorta,nRet1);
					else
						printf("Atendeu a porta %d com sucesso\n",nPorta);	
					
					Sleep(200);
					//disca para o numero
					nRet1 = dg_Dial(nPorta,szTemp,100,dtTone);
					if (nRet1 != DG_EXIT_SUCCESS)
						printf("Erro ao discar nRet.: %d\n",nRet1);
					else
						printf("Discou com sucesso\n");
					break;

				case 'f': 
				case 'F'://Seta frequencia
					printf("\nEntre com a frequencia: ");
					fflush(stdin);
					scanf_s("%s",szTemp,sizeof(szTemp));
					nFrequencia = atoi(szTemp);

					for (nForCards=1;nForCards<=nCardsCount;nForCards++)
					{
						//Seta a frequencia
						nRet1 = dg_SetCardDetections(nForCards,CFG_DETECT_FREQTONE1,nFrequencia,0);
						if (nRet1 != DG_EXIT_SUCCESS)
							printf("Erro ao setar a frequencia %d. nRet.: %d\n",nForCards,nRet1);
						else
							printf("Setou a frequencia para a placa %d com sucesso\n",nForCards);
					}
					break;

				case 'l': 
				case 'L'://Seta limiar de Silencio
					printf("\nEntre com o valor do limiar de silencio: ");
					fflush(stdin);
					scanf_s("%s",szTemp,sizeof(szTemp));
					nLimiarSilencio = atoi(szTemp);

					for (nForPortas=1;nForPortas<=nPortsCount;nForPortas++)
					{
						//Seta o limiar de silencio
						nRet1 = dg_SetSilenceThreshold(nForPortas,nLimiarSilencio);
						if (nRet1 != DG_EXIT_SUCCESS)
							printf("Erro ao setar o limiar de silencio %d .nRet.: %d \n",nForPortas,nRet1);
					}
					break;

				case 'v':
				case 'V':
					ret = dg_GetVersion(1);
					sprintf(szMsg,"Versao do firmware: %x\n",ret);
					print_event(szMsg,1);
					break;

				case 'm':
				case 'M':
					print_menu();
					break;

				case 'k':
				case 'K':
					print_cAmostras();
					ch = getch();
					break;
		}
	}	
	return 0;
}

